<template>
    <div v-if="orderType === 'PRODUCT'">
        <span
            style="color: #333333; font-size: medium; font-weight: bolder; padding-left: 10px;"
            v-show="extraIngredients.length > 0"
        >
        </span>
        <span v-show="false">{{ extraSize(extraIngredients.length) }} </span>
        <v-chip-group multiple active-class="orange orange--text " max="9" column>
            <v-chip
                v-show="extraIngredients.length > 0"
                small
                class="ma-1"
                color="#3949AB "
                label
                outlined
                v-for="extraingredient in extraIngredients"
                :key="extraingredient.id"
            >
                {{ extraingredient.localizedName + ' ' }}
                <span v-if="extraingredient.price > 0" style="color: #1976d2;">
                    {{ '(' + '$' + extraingredient.price + ')' }}
                </span>
            </v-chip>
        </v-chip-group>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { db } from '@/config/firebase';
import { ORDER_DISH, ORDER_DISH_EXTRAINGREDIENT, ORDERS } from '@/config/collectionsName';
import { serializeExtraIngredientOrderDish } from '@/config/serializables';
import { ExtraIngredientOrderDish } from '@/model/order/ExtraIngredientOrderDish';

@Component
export default class ExtraIngredientsItem extends Vue {
    @Prop({ default: '' })
    readonly disId!: string;

    readonly extraIngredients: ExtraIngredientOrderDish[] = [];

    @Prop({ default: '' })
    readonly orderId!: string;
    @Prop({ default: '' })
    readonly orderType!: string;
    @Prop({ default: '' })
    readonly ingredientId!: string;

    created() {
        this.$bind(
            'extraIngredients',
            db
                .collection(ORDERS)
                .doc(this.orderId)
                .collection(ORDER_DISH)
                .doc(this.disId)
                .collection(ORDER_DISH_EXTRAINGREDIENT)
                .where('ingredientId', '==', this.ingredientId)
                .where('selected', '==', true),
            { serialize: serializeExtraIngredientOrderDish }
        );
    }

    extraSize(size: number) {
        this.$emit('extraSize', size);
    }
}
</script>

<style scoped></style>
